%% DT_T1_d2.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #1
% Demo 2
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Datasetin peruspiirteet
%
% Tutustutaan datamatriisiin X, jossa on 
%  dim rivi ja N saraketta. 
% Sarakkeet vastaavat havaintoja ('observation', tilastoyksikk), 
%  esimerkiksi ihmisi, joille on tehty kyselytutkimus.
% Rivit vastaavat ihmisilt kysyttj arvoja ('variable'), 
%  esim. pituus ja paino.
%
% Yleens suureet toki tiedetn - tss demossa
%  niit ei anneta, vaan lukija voi itse ptell,
%  mit ne voisivat olla...
%
%
%          [ X(1,1)   X(1,2)  ... X(1,N)   ]
%          [ X(2,1)   ...         X(2,N)   ]
%   X   =  [ ...                  ...      ]
%          [ ...                  ...      ]
%          [ X(dim,1) ...         X(dim,N) ]
%
%
% HUOM! Matlab ja muutenkin keskimrin useammin
%  matriisi ksitelln toisinpin eli havainnot
%  ovat rivej ja dimensio kasvaa sarakkeittain.
%  Tarvittavan muunnoksen Matlabissa saa 
%  transponoimalla matriisin X' (hipsu).
% 

%% Ladataan datatiedosto Matlabiin
%
% Matlab lukee Matlabin omaa binaarista tietotyyppi
%  load X.mat.
% Mrmuotoista tekstitiedostoa voi lukea sisn
%  muun muassa komennolla

load -ascii X.csv

%% Katso lukuarvot
% 
% Huomaa, ett aivan alussa on Matlabin kerroin 10^x.
%  Voi olla helpompaa lukea alkuperist csv-tiedostoa,
%  varsinkin kun se tss tapauksessa on pieni.

X

%% Katsotaan matriisin koko
%
%     ** VINK
%     **
%     ** Puolipisteell voi erottaa Matlabin komennot toisistaan.
%     ** Rivin lopussa puolipiste est tulosten kirjoittumisen
%     **  nytlle.
%

size(X)

dim  = size(X,1);
N    = size(X,2);

disp(['Matriisissa X on ' num2str(N) ' nytett (saraketta) ja']);
disp([' ' num2str(dim) ' dimensiota (rivi).']);

%% Matriisin alkioihin viittaaminen
%
% Voidaan poimia rivej, sarakkeita tai yksittisi arvoja.
% HUOM! Indeksinti alkaa ykksest.

X(:, 3)

X(3, 5)

X([1:3], [2:4])

%% Minimi- ja maksimiarvot
%
% Etsitn esim. 1. suureen minimi- ja maksimiarvot.

min(X(1,:))
max(X(1,:))

%% Keskiarvo
%
% Kirjoita oma funktio myMean.m, joka laskee keskiarvon.
%
% $$ \bar{x} = (1/N) \sum_{k=1}^{N} x_k $$
%
% Varmista, ett tuottaa saman kuin Matlabin oma mean(x).

myMean(X(1,:))  % oma
mean(X(1,:))    % Matlabin

%% Varianssi
%
% Kirjoita oma funktio myVar.m, joka laskee 
% rellisen populaation varianssin.
%
% $$ s = (1/N-1) \sum_{k=1}^{N} (x_k - m)^2 $$
%
% Varmista, ett tuottaa saman kuin Matlabin oma var(x).
% Kutsutaan

myVar(X(1,:))   % oma
var(X(1,:))     % Matlabin

%% Piirretn histogrammit muuttujittain
%
% Histogrammista nhdn, kuinka muuttujat arvot ovat jakautuneet.
%  Nin pienell nytemrll N=15 histogrammi ei vlttmtt ole
%  niin informatiivinen kuin isolla mrll.

figure(121);     % avaa/aktivoi ikkuna "Figure 21"
clf;            % clf = "clear figure"
hist(X(1,:))

%% Lineaarinen korrelaatiokerroin

korrelaatioKertoimet = corrcoef(X')

%% Pareittain piirtminen 'scatter-plot'
% Vahva lineaarinen korrelaatio nkyy hajontakuviossa.
% Katso vaihtoehtoisesti 'help scatter'

for m = 1 : dim
    for n = m+1 : dim
        figure(122); clf;
        plot(X(m,:), X(n,:), 'kx');
        grid on;
        title(['Muuttujat ' num2str(m) ' ja ' num2str(n) ...
            ', kerroin = ' num2str(korrelaatioKertoimet(m,n))]);
        xlabel(['Muuttuja #' num2str(m)]);
        ylabel(['Muuttuja #' num2str(n)]);
        fprintf(1, 'Paina jotakin nppint...\n');
        pause;
    end;
end;

%% Mit muuttujia olikaan kyseess?
%
% HUOM! Tiedot eivt ole todellisia mittauksia lainkaan.
%  Niill on kuitenkin joku ajatuksellinen tausta.
%  Perustele valintasi.
%
% Muuttuja #1: Pituus (cm)
% Muuttuja #2: Paino (kg)
% Muuttuja #3:
% Muuttuja #4:
% Muuttuja #5:
% Muuttuja #6:
% Muuttuja #7:

