%% DT_T1_d3.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #1
% Demo 3
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Konvoluutio 
%
% Katso luentokalvojen lukua 2 ja paperilaskarien tehtv H1/1, 
%  jossa esitelln konvoluutiosuotimen kaava
%
% $$ g_k = \sum_{m=-\infty}^{\infty} f_m s_{k-m} $$
%
%  tai toisella notaatiolla
%
% $$ y[n] = \sum_{k=-\infty}^{\infty} x[k] h[n-k] $$ 
%
%  jossa 
%
% $$ y[n] \equiv g_k $$,
% $$ x[k] \equiv f_m $$ ja 
% $$ h[n-k] \equiv s_{k-m} $$.
%

%% H1/1 a

f = 1
s = [2 1]
g = conv(f,s)

t = [0 : length(g)-1];
figure(131); clf;
stem(t, g);
title('H1/1 a: Ulostulosekvenssi g_k');
axis([-0.2 5.4 -1.2 5.2]);

%% H1/1 b

f = [2 -1]
s = [-1 2 1]
g = conv(f,s)

t = [0 : length(g)-1];
figure(132); clf;
stem(t, g);
title('H1/1 b: Ulostulosekvenssi g_k');
axis([-0.2 5.4 -2.2 5.2]);

%% Mit ovat lukujonot f, s, g?
%
% f on tss tulosignaali, esim. digitoitua puhetta
% s on suotimen impulssivaste, esim. alipstsuodin tai ekvalisaattori
% g on lhtsignaali, esim. suodatettua digitoitua puhetta
%
% Kyseess on siis toisaalta differenssiyhtlill laskemista.
%  Esim. kun s = [-1 2 1], niin
%
% $$ g_k = \sum_m f_m s_{k-m}$$
%
% $$     = \sum_m s_m f_{k-m}$$
%
% $$     = s_0 f_{k-0} + s_1 f_{k-1} + s_2 f_{k-2} $$
%
% $$     = -1 f_k + 2 f_{k-1} + f_{k-2} $$
%

%% Muunnosalueen ksittely
%
% Katso tehtv H1/2, jossa taajuusalueessa konvoluutiosumman
%  kaava tulee muotoon
%
%  G(w) = S(w)F(w)
%
% jossa G(w) ja S(w) ovat signaalin spektrej ja S(w)
%  suotimen taajuusvaste ja jossa diskreettiaikainen 
%  Fourier-muunnos on w:n funktio:
%
% $$ F(\omega) = \sum_{m=-\infty}^{\infty} f_m e^{-i \omega m} $$
%
% Kompleksinen eksponenttifunktio hajoaa siniksi ja kosiniksi
%  Eulerin kaavan mukaisesti:
%
% $$ e^{i \omega}  = \cos(\omega) + i \sin(\omega) $$
%
% $$ e^{-i \omega} = \cos(\omega) - i \sin(\omega) $$
%

%% Suotimen taajuusesitys
%
% Piirretn suotimen amplitudivaste |S(w)|
%  w:n funktiona vlill w = 0..pi.
% Huomaa, ett S(w) on yleens aina kompleksiarvoinen,
%  joten siit otetaan itseisarvo.

s = [-1 2 1];
[S1, w] = freqz(s, 1);

figure(133); clf;
plot(w, 20*log10(abs(S1)));
grid on;
xlabel('Taajuus \omega');
ylabel('dB');

% Kuvaajasta voidaan nhd, ett kyseess on ernlainen
%  kaistanpstsuodin, koska sek matalilla ett 
%  korkeilla taajuuksilla suodin "vaimentaa" ja 
%  keskitaajuuksilla "vahvistaa".

