%% DT_T1_d4.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #1
% Demo 4
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% nitiedoston ksittely Matlabissa

% Luetaan WAV-nitiedosto Matlabiin
[x, fs] = wavread('testi1.wav');

%% Luetut muuttujat
%
% x   sislt digitoidun nytejonon
% fs  on nytteenottotaajuus
%
% Vektori x muistissa voidaan havainnollistaa kuvana.
% Olettaen ett fs=22050 eli joka sekunti 22050 nytett:
%
% indeksinro     1          22050        44100
% x              |------------|------------|-----
% aika           0           1.0s         2.0s

fs

x(1)
x(end)
min(x)
max(x)
length(x)

%% Lukujon on pelkki numeroita!!!

x

%% Kuuntele!
%
% JOS nen kanssa ongelmia, niin tarkista, ett nt ei
%  ole vaimennettu, piuhat ovat oikeissa rei'iss, yms.
%  Viimeisen keinona on kirjoittaa vektori x takaisin 
%  nitiedostoksi ja kuunnella se kyttjrjestelmn 
%  musiikkisoittimesta:
%    wavwrite(x, fs, 8, 'ulos.wav');

soundsc(x, fs);

%% Piirretn lukujono x eli aaltomuoto

figure(141); clf;
plot(x)
grid on;
xlabel('x:n indeksinumerot')

%% Piirtminen aika-akselilla

M = length(x);
t = [0 : M-1]/fs;
figure(142); clf;
plot(t, x);
grid on;
xlabel('aika (sekuntia)');

%% Mit eroja signaalissa on puheen ja musiikin aikana?

%% Koska luvut ovat numeroita, niit voi muokata vapaasti
%
% Voit kokeilla itseksesi:

% Knnetn lukujono ympri ja soitetaan:
%
% soundsc(flipud(x), fs);

% Kerrotaan lukujonon alkupt 1:ll ja loppupt 0:lla:
%
% soundsc(x.*linspace(1, 0, length(x))', fs);

% Soitetaan lukujonoa eri nopeudella kuin pitisi:
%
% soundsc(x, 1.8*fs);

% x on aikasarja eli vierekkiset nytteet ovat toisistaan
%  riippuvaisia. Demossa #2 oli mitattu ihmisist eri ominaisuuksia.
%  Ihmisten osalta ksittelyjrjestyksell ei ole vli,
%  mutta jos nisignaalin nytteiden jrjestys muutetaan, niin...:
%
% soundsc(x(randperm(length(x))), fs);

%% Piirretn pieni pala signaalin aaltomuotoa ja sen spektri
%
% Valitaan kaksi lyhytt ptk. Valitaan 1024
%  nytett, joka vastaa 1024/22050 sekuntia pituudeltaan.
%
% Kuvaajaan 143a tulee osa soinnillista vokaalinnett.
%  Nytt jaksolliselta. Jakson pituus ___ nytett.
%  Kun 22050 nytett mahtuu 1 sekuntiin, niin ___ nytett
%  tarkoittaa T_0 = ___ sekuntia.
%
% Kuvaajaan 143b tulee saman vokaalinytteen spektri, 
%  jota voi zoomata matalille taajuuksille.
%  (Valitse suurennuslasi piirrosikkunan valikosta
%  ja ved vasen hiiren painike pohjassa kapea laatikko.)
%  Noin taajuudella f_0 = 120 Hz nkyy ensimminen piikki,
%  sitten harmonisilla monikerroilla lis.
%
% Yksi puhdas siniaalto taajuudella f0 eli x(t) = sin(2 pi f0 t)
%  tuottaa yhden piikin spektriin taajuudelle f0.
%  Harmoniset taajuudet f0, 2f0, 3f0, 4f0, ...

figure(143); clf;
myDrawSS(x(47000:48023), fs)

%% Analysoidaan toinen pala

% Kuvaajassa 144 on ptk soinnittomasta s-nteest.
%  Aaltomuodossa ei ole jaksoa. Spektri on tasaisempi
%  ja voimaikkammat taajuuskomponentit ovat 3-8 kHz:n alueella.

figure(144); clf;
myDrawSS(x(37000:38023), fs)

%% Miksi siis lyhyit aikaikkunoita?
%
% Pitkss nytteess Fourier-muunnos "kadottaa ajantajun".
% Kts. esim:
%
% myDrawSS(x, fs)

%% Tehokas puheen/musiikin esitystapa on spektrogrammi.
%
% Spektrogrammissa x-akselilla on aika, y-akselilla
%  taajuus ja z-akselilla vrill kuvattuna kunakin 
%  ajan hetkell kunkin taajuuskomponentin (siniaalto
%  tuolla taajuudella) voimakkuus.

figure(145); clf;
spectrogram(x, 1024, 256, 1024, fs, 'yaxis');
colorbar;
% Octavessa:
%specgram(x, 1024, fs, 1024, 256);

