%% DT_T1_d5.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #1
% Demo 5
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Signaalin suodattaminen
%
% Nimemiskytnt: luentojen ja paperilaskarien f, s ja g
%  ovat tss Matlab-tiedostossa x, h ja y.
%
% Tss demossa konvoloidaan sytesekvenssi x
%  suotimen impulssivastejonon h kanssa ja 
%  saadaan ulostulosekvenssi y. Suodin h
%  voidaan ajatella stereoissa tai musiikkisoittimessa
%  olevaksi ekvalisaattoriksi, joka voi siis
%  vahvistaa tai vaimentaa taajuusalueita (bassot,
%  diskantit, ...).

%% Sytesekvenssi x
%
% Laskareissa H1/1 ja luentokalvoissa tm on siis jono f_k.
%
% Kuullaan jatkuva tasainen piippaus taustalla.
%  Nhdn spektrogrammista juova yhdell taajuudella.
%  Juovan taajuusarvo f_n vastaa siis kosinikomponenttia
%  n(t) = cos(2 pi f_n t), joka koetaan hiriksi ja
%  halutaan suodattaa pois.

[x, fs] = wavread('testi2.wav');
soundsc(x, fs);

figure(151); clf;
spectrogram(x, 1024, 256, 1024, fs, 'yaxis');
% Octave: specgram(x, 1024, fs, 1024, 256);
colorbar

%% Kaistanestosuodin
%
% Kehitetn sopivan kaistanestosuodin, joka poistaisi
%  hiritaajuuden f_n. 
%
% Valitse kaksi rajataajuutta niin, 
%  ett hiri f_n j niiden vliin. 
%
% Kokeile N sellaiseksi, ett vaimennus on "tarpeeksi tehokasta". 
%  Voit kuunnella ja ptell mik desibelivaimennus on riittv.
%  Alkutilanteessa N=2 on aivan liian pieni.
% 

% MUUTA NIT KAHTA:
N  = 2;        % asteluku: mit suurempi aste, sit parempi vaimennus
rajataajuudet = [1500 2000];  % estokaistan alue Hertzeiss

% L MUUTA MITN ALLA OLEVAA:
h  = fir1(N, 2*rajataajuudet/fs, 'stop');  % Matlab laskee h:n
[H1, w1] = freqz(h, 1, 512, fs);  % lasketaan amplitudivaste
mag = 20*log10(abs(H1));

figure(152); clf;                % piirretn amplitudivaste...
plot(w1, mag);
grid on;
title('Kaistanestosuotimen amplitudivaste |H(\omega)|');
xlabel('taajuus (Hz)');
ylabel('dB');

hold on;        % piirretn kuvaajaan rajataajuudet...
p2 = plot([rajataajuudet(1) rajataajuudet(1)], [min(mag) max(mag)],'k');
p3 = plot([rajataajuudet(2) rajataajuudet(2)], [min(mag) max(mag)],'c');
set([p2 p3],'Linewidth',3);
legend({'Suotimen magnitudivaste', ...
    ['Estokaista alkaa ' num2str(rajataajuudet(1)) ' Hz'], ...
    ['Estokaista loppuu ' num2str(rajataajuudet(2)) ' Hz']}, ...
    'Location','SouthEast');

%% Suodatus
%
%              |-------|
%     x ------>|   h   |------>  y 
%              |-------|
%
% Konvoloidaan sytevektori x impulssivasteen h kanssa,
%  joilloin saadaan auodatettu ulostulosekvenssi y. 
% Paperilaskareissa ja luentokalvoissa vastaavasti f_k, s_k, g_k:
%
%              |-------|
%     f ------>|   s   |------>  g 
%              |-------|
%

y = conv(h, x);  

figure(153); clf;
spectrogram(y, 1024, 256, 1024, fs, 'yaxis');
% Octave: specgram(y, 1024, fs, 1024, 256);
colorbar

soundsc(y, fs);   
% POISTUIKO hirini? 
% Jos ei, muuta rajataajuutta ja/tai suotimen pituutta N.

%% Piirretn suotimen impulssivastejono
figure(154); clf;
stem(h);
xlabel('n');
ylabel('h[n]');
title(['Suotimen impulssivaste eli suodinjono h[n], jonka pituus ' num2str(length(h))]);
grid on;

%% Piirretn pieni pala alkuperist ja suodatettua signaalia
figure(155); clf;
xlabel('n');
title('Signaali ennen ja jalkeen suodatuksen');
plot([35000:47000], x(35000:47000), 'b', [35000:47000], y(35000:47000), 'g');
legend({'Alkuperainen','Suodatettu'});
%soundsc(x(35000:47000), fs)
%soundsc(y(35000:47000), fs)


%% Vertaus paperilaskareihin
% 
% Huomaa, ett paperilaskareissa H1/1b vektori
%  f oli 2 merkki pitk ja s oli 3 merkki pitk.
%  Nyt f:n pituus on noin 144000 ja s:n pituus N+1,
%  eli kun laskenta-algoritmin tuntee, niin laskut
%  voi tehd (onneksi) tietokoneella.


